﻿Public Class Form1

    Private Sub comboFolders_SelectedIndexChanged(sender As System.Object, e As System.EventArgs) Handles comboFolders.SelectedIndexChanged
        listBoxHiddenItems.BeginUpdate()
        listBoxHiddenItems.Items.Clear()
        Dim selectedFolder As AddinExpress.MAPI.Folder = AdxmapiStoreAccessor1.MsgStores(0).RootFolder.Folders(1).Folders(comboFolders.SelectedIndex)
        For Each item As AddinExpress.MAPI.MapiItem In selectedFolder.HiddenMapiItems
            listBoxHiddenItems.Items.Add(item.GetProperty(AddinExpress.MAPI.ADXMAPIPropertyTag._PR_MESSAGE_CLASS))
        Next
        listBoxHiddenItems.EndUpdate()
    End Sub

    Private Sub btnCreate_Click(sender As System.Object, e As System.EventArgs) Handles btnCreate.Click
        Dim rnd As Random = New Random()
        Dim selectedFolder As AddinExpress.MAPI.Folder = AdxmapiStoreAccessor1.MsgStores(0).RootFolder.Folders(1).Folders(comboFolders.SelectedIndex)
        Dim hiddenItem As AddinExpress.MAPI.MapiItem = selectedFolder.HiddenMapiItems.Add()
        hiddenItem.SetProperty(AddinExpress.MAPI.ADXMAPIPropertyTag._PR_DISPLAY_NAME, "My first hidden item")
        hiddenItem.SetProperty(AddinExpress.MAPI.ADXMAPIPropertyTag._PR_MESSAGE_CLASS, rnd.Next(1000).ToString())
        comboFolders_SelectedIndexChanged(Me, EventArgs.Empty)
    End Sub

    Private Sub btnDelete_Click(sender As System.Object, e As System.EventArgs) Handles btnDelete.Click
        If (listBoxHiddenItems.SelectedIndex > -1) Then
            Dim selectedFolder As AddinExpress.MAPI.Folder = AdxmapiStoreAccessor1.MsgStores(0).RootFolder.Folders(1).Folders(comboFolders.SelectedIndex)
            selectedFolder.HiddenMapiItems.Remove(listBoxHiddenItems.SelectedIndex)
        End If
        comboFolders_SelectedIndexChanged(Me, EventArgs.Empty)
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        AdxmapiStoreAccessor1.Initialize(True)
        Dim container As AddinExpress.MAPI.Folder = AdxmapiStoreAccessor1.MsgStores(0).RootFolder.Folders(1)
        For Each folder As AddinExpress.MAPI.Folder In container.Folders
            comboFolders.Items.Add(folder.GetProperty(AddinExpress.MAPI.ADXMAPIPropertyTag._PR_DISPLAY_NAME))
        Next
        comboFolders.SelectedIndex = 0
    End Sub

    Private Sub Form1_FormClosing(sender As System.Object, e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        AdxmapiStoreAccessor1.LogOff()
    End Sub
End Class
